#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define N 3

void makemat(double A[][N], double *b, char* fn)
{
  FILE *fp;
  int i, j;
  char s[N*10];
  fp = fopen(fn, "r");
  if(fp == NULL){
	perror("fopen:");
	exit(EXIT_FAILURE);
  }
  // matrix
  for(i=0;i<N; i++){
	char *ret, *tp;
	ret = fgets(s, N*10, fp);
	if(ret==NULL){
	  perror("fgets:");
	  exit(EXIT_FAILURE);
	}
	tp = strtok(s, " ");
	for(j=0; j<N; j++){
	  sscanf(tp, "%lf", &A[i][j]);
	  tp = strtok(NULL, " ");
	}
  }
  // vector
  {
	char *ret, *tp;
	ret = fgets(s, N*10, fp);
	if(ret==NULL){
	  perror("fgets:");
	  exit(EXIT_FAILURE);
	}
	tp = strtok(s, " ");
	for(j=0; j<N; j++){
	  sscanf(tp, "%lf", &b[j]);
	  tp = strtok(NULL, " ");
	}
  }
  fclose(fp);
}
void forward_elimination(double A[][N], double *b)
{
  int i, j, k;
  double p;
  for(i=0; i<N; i++){

	p = A[i][i];
	for(j=i; j<N; j++){
	  A[i][j] /= p;
	}
	b[i] /= p;

	for(j=i+1; j<N; j++){
	  p = A[j][i];
	  for(k=i; k<N; k++){
		A[j][k] -= A[i][k] * p;
	  }
	  b[j] -= b[i] * p;
	}
  }
}
void backward_substitution(double A[][N], double *b){}
void printresult(double A[][N], double *b)
{
  int i, j;
  for(i=0; i<N; i++){
	for(j=0; j<N; j++){
	  printf(" %f", A[i][j]);
	}
	printf("\n");
  }
  for(i=0; i<N; i++){
	printf(" %f", b[i]);
  }
  printf("\n");
}

int main(int argc, char **argv){
  double A[N][N], b[N];
  if(argc!=2){
	printf("usage: %s datafile\n", argv[0]);
	return(EXIT_FAILURE);
  }
  makemat(A, b, argv[1]);
  forward_elimination(A, b);
  backward_substitution(A, b);
  printresult(A, b);
  return EXIT_SUCCESS;
}
